diff --git a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
index d9df13fac..6bc6a97b5 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
@@ -297,201 +319,200 @@ public class ScreenAchievements extends Screen
         renderBackground();
 
         if (drawSidebar()){
-            overlayBackground(0, pageListRight, top, bottom, 0x202020);
+            overlayBackground(0, this.pageListRight, this.top, this.bottom, 0x202020);
         }
 
         renderAchievementsPanel(mx, my, partialTick);
 
-        overlayBackground(0, width, 0, top, 0x404040);
-        overlayBackground(0, width, bottom, height, 0x404040);
-        overlayBackground(pageListRight, viewportLeft, top, bottom, 0x404040);
+        overlayBackground(0, this.width, 0, this.top, 0x404040);
+        overlayBackground(0, this.width, this.bottom, this.height, 0x404040);
+        overlayBackground(this.pageListRight, this.viewportLeft, this.top, this.bottom, 0x404040);
 
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        GL11.glDisable(GL11.GL_ALPHA_TEST);
-        GL11.glShadeModel(GL11.GL_SMOOTH);
-        GL11.glEnable(GL11.GL_TEXTURE_2D);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+//        GL11.glDisable(GL11.GL_ALPHA_TEST);
+//        GL11.glShadeModel(GL11.GL_SMOOTH);
+//        GL11.glEnable(GL11.GL_TEXTURE_2D);
 
         super.render(mx, my, partialTick); // Draw Buttons
-        GL11.glEnable(GL11.GL_DEPTH_TEST);
-        GL11.glEnable(GL11.GL_LIGHTING);
+        GLRenderer.enableState(State.DEPTH_TEST);
+        GLRenderer.globalSetLightEnabled(true);
         Lighting.disable();
 
-        GL11.glDisable(GL11.GL_LIGHTING);
-        GL11.glDisable(GL11.GL_DEPTH_TEST);
-        GL11.glEnable(GL11.GL_TEXTURE_2D);
-        GL11.glShadeModel(GL11.GL_FLAT);
-        GL11.glEnable(GL11.GL_ALPHA_TEST);
+        GLRenderer.globalSetLightEnabled(false);
+        GLRenderer.disableState(State.DEPTH_TEST);
+//        GL11.glEnable(GL11.GL_TEXTURE_2D);
+//        GL11.glShadeModel(GL11.GL_FLAT);
+//        GL11.glEnable(GL11.GL_ALPHA_TEST);
 
         if (drawSidebar()){
-            Scissor.enable(pageListLeft, top, pageListRight - pageListLeft, bottom - top);
+            Scissor.enable(this.pageListLeft, this.top, this.pageListRight - this.pageListLeft, this.bottom - this.top);
             int pagesListHeight = getTotalPagesListHeight();
-            int pagesListY = top - (int) pageListScrollAmount;
-            if (pagesListHeight < bottom - top) {
-                pagesListY = top + (bottom - top - pagesListHeight) / 2;
+            int pagesListY = this.top - (int) this.pageListScrollAmount;
+            if (pagesListHeight < this.bottom - this.top) {
+                pagesListY = this.top + (this.bottom - this.top - pagesListHeight) / 2;
             }
-            if (my >= top && my <= bottom) {
-                hoveredPage = drawPagesListItems(pageListLeft + PADDING - 4, pagesListY, pageListRight - PADDING, mx, my);
+            if (my >= this.top && my <= this.bottom) {
+                this.hoveredPage = drawPagesListItems(this.pageListLeft + PADDING - 4, pagesListY, this.pageListRight - PADDING, mx, my);
             } else {
-                hoveredPage = drawPagesListItems(pageListLeft + PADDING - 4, pagesListY, pageListRight - PADDING, -1, -1);
+                this.hoveredPage = drawPagesListItems(this.pageListLeft + PADDING - 4, pagesListY, this.pageListRight - PADDING, -1, -1);
             }
             Scissor.disable();
         }
 
         {
-            GL11.glDisable(GL11.GL_TEXTURE_2D);
-            GL11.glEnable(GL11.GL_BLEND);
-            GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-            GL11.glDisable(GL11.GL_ALPHA_TEST);
-            GL11.glShadeModel(GL11.GL_SMOOTH);
+            GLRenderer.pushFrame();
+            GLRenderer.setShader(Shaders.COLOR);
+            GLRenderer.enableState(State.BLEND);
+            GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+//            GL11.glDisable(GL11.GL_ALPHA_TEST);
+//            GL11.glShadeModel(GL11.GL_SMOOTH);
 
             byte fadeDist = 4;
-            Tessellator tessellator = Tessellator.instance;
+            TessellatorGeneral tessellator = GLRenderer.getTessellator();
             if (drawSidebar()) {
                 tessellator.startDrawingQuads();
-                tessellator.setColorRGBA_I(0, 0);
-                tessellator.addVertexWithUV(pageListLeft, top + fadeDist, 0.0D, 0.0D, 1.0D);
-                tessellator.addVertexWithUV(pageListRight, top + fadeDist, 0.0D, 1.0D, 1.0D);
-                tessellator.setColorRGBA_I(0, 255);
-                tessellator.addVertexWithUV(pageListRight, top, 0.0D, 1.0D, 0.0D);
-                tessellator.addVertexWithUV(pageListLeft, top, 0.0D, 0.0D, 0.0D);
+                tessellator.setColor2i(0, 0);
+                tessellator.addVertexWithUV(this.pageListLeft, this.top + fadeDist, 0.0D, 0.0D, 1.0D);
+                tessellator.addVertexWithUV(this.pageListRight, this.top + fadeDist, 0.0D, 1.0D, 1.0D);
+                tessellator.setColor2i(0, 255);
+                tessellator.addVertexWithUV(this.pageListRight, this.top, 0.0D, 1.0D, 0.0D);
+                tessellator.addVertexWithUV(this.pageListLeft, this.top, 0.0D, 0.0D, 0.0D);
                 tessellator.draw();
 
                 tessellator.startDrawingQuads();
-                tessellator.setColorRGBA_I(0, 255);
-                tessellator.addVertexWithUV(pageListLeft, bottom, 0.0D, 0.0D, 1.0D);
-                tessellator.addVertexWithUV(pageListRight, bottom, 0.0D, 1.0D, 1.0D);
-                tessellator.setColorRGBA_I(0, 0);
-                tessellator.addVertexWithUV(pageListRight, bottom - fadeDist, 0.0D, 1.0D, 0.0D);
-                tessellator.addVertexWithUV(pageListLeft, bottom - fadeDist, 0.0D, 0.0D, 0.0D);
+                tessellator.setColor2i(0, 255);
+                tessellator.addVertexWithUV(this.pageListLeft, this.bottom, 0.0D, 0.0D, 1.0D);
+                tessellator.addVertexWithUV(this.pageListRight, this.bottom, 0.0D, 1.0D, 1.0D);
+                tessellator.setColor2i(0, 0);
+                tessellator.addVertexWithUV(this.pageListRight, this.bottom - fadeDist, 0.0D, 1.0D, 0.0D);
+                tessellator.addVertexWithUV(this.pageListLeft, this.bottom - fadeDist, 0.0D, 0.0D, 0.0D);
                 tessellator.draw();
 
                 tessellator.startDrawingQuads();
-                tessellator.setColorRGBA_I(0, 0);
-                tessellator.addVertexWithUV(viewportLeft, top + fadeDist, 0.0D, 0.0D, 1.0D);
-                tessellator.addVertexWithUV(viewportRight, top + fadeDist, 0.0D, 1.0D, 1.0D);
-                tessellator.setColorRGBA_I(0, 255);
-                tessellator.addVertexWithUV(viewportRight, top, 0.0D, 1.0D, 0.0D);
-                tessellator.addVertexWithUV(viewportLeft, top, 0.0D, 0.0D, 0.0D);
+                tessellator.setColor2i(0, 0);
+                tessellator.addVertexWithUV(this.viewportLeft, this.top + fadeDist, 0.0D, 0.0D, 1.0D);
+                tessellator.addVertexWithUV(this.viewportRight, this.top + fadeDist, 0.0D, 1.0D, 1.0D);
+                tessellator.setColor2i(0, 255);
+                tessellator.addVertexWithUV(this.viewportRight, this.top, 0.0D, 1.0D, 0.0D);
+                tessellator.addVertexWithUV(this.viewportLeft, this.top, 0.0D, 0.0D, 0.0D);
                 tessellator.draw();
 
                 tessellator.startDrawingQuads();
-                tessellator.setColorRGBA_I(0, 255);
-                tessellator.addVertexWithUV(viewportLeft, bottom, 0.0D, 0.0D, 1.0D);
-                tessellator.addVertexWithUV(viewportRight, bottom, 0.0D, 1.0D, 1.0D);
-                tessellator.setColorRGBA_I(0, 0);
-                tessellator.addVertexWithUV(viewportRight, bottom - fadeDist, 0.0D, 1.0D, 0.0D);
-                tessellator.addVertexWithUV(viewportLeft, bottom - fadeDist, 0.0D, 0.0D, 0.0D);
+                tessellator.setColor2i(0, 255);
+                tessellator.addVertexWithUV(this.viewportLeft, this.bottom, 0.0D, 0.0D, 1.0D);
+                tessellator.addVertexWithUV(this.viewportRight, this.bottom, 0.0D, 1.0D, 1.0D);
+                tessellator.setColor2i(0, 0);
+                tessellator.addVertexWithUV(this.viewportRight, this.bottom - fadeDist, 0.0D, 1.0D, 0.0D);
+                tessellator.addVertexWithUV(this.viewportLeft, this.bottom - fadeDist, 0.0D, 0.0D, 0.0D);
                 tessellator.draw();
             } else {
                 tessellator.startDrawingQuads();
-                tessellator.setColorRGBA_I(0, 0);
-                tessellator.addVertexWithUV(0, top + fadeDist, 0.0D, 0.0D, 1.0D);
-                tessellator.addVertexWithUV(width, top + fadeDist, 0.0D, 1.0D, 1.0D);
-                tessellator.setColorRGBA_I(0, 255);
-                tessellator.addVertexWithUV(width, top, 0.0D, 1.0D, 0.0D);
-                tessellator.addVertexWithUV(0, top, 0.0D, 0.0D, 0.0D);
+                tessellator.setColor2i(0, 0);
+                tessellator.addVertexWithUV(0, this.top + fadeDist, 0.0D, 0.0D, 1.0D);
+                tessellator.addVertexWithUV(this.width, this.top + fadeDist, 0.0D, 1.0D, 1.0D);
+                tessellator.setColor2i(0, 255);
+                tessellator.addVertexWithUV(this.width, this.top, 0.0D, 1.0D, 0.0D);
+                tessellator.addVertexWithUV(0, this.top, 0.0D, 0.0D, 0.0D);
                 tessellator.draw();
 
                 tessellator.startDrawingQuads();
-                tessellator.setColorRGBA_I(0, 255);
-                tessellator.addVertexWithUV(0, bottom, 0.0D, 0.0D, 1.0D);
-                tessellator.addVertexWithUV(width, bottom, 0.0D, 1.0D, 1.0D);
-                tessellator.setColorRGBA_I(0, 0);
-                tessellator.addVertexWithUV(width, bottom - fadeDist, 0.0D, 1.0D, 0.0D);
-                tessellator.addVertexWithUV(0, bottom - fadeDist, 0.0D, 0.0D, 0.0D);
+                tessellator.setColor2i(0, 255);
+                tessellator.addVertexWithUV(0, this.bottom, 0.0D, 0.0D, 1.0D);
+                tessellator.addVertexWithUV(this.width, this.bottom, 0.0D, 1.0D, 1.0D);
+                tessellator.setColor2i(0, 0);
+                tessellator.addVertexWithUV(this.width, this.bottom - fadeDist, 0.0D, 1.0D, 0.0D);
+                tessellator.addVertexWithUV(0, this.bottom - fadeDist, 0.0D, 0.0D, 0.0D);
                 tessellator.draw();
             }
-            GL11.glEnable(GL_TEXTURE_2D);
-            GL11.glEnable(GL11.GL_ALPHA_TEST);
+            GLRenderer.popFrame();
         }
 
-        if (hoveredAchievement != null){
-            drawAchievementToolTip(hoveredAchievement, mx, my);
+        if (this.hoveredAchievement != null){
+            drawAchievementToolTip(this.hoveredAchievement, mx, my);
         }
 
         if (drawSidebar()) {
             drawPagesListScrollBar(mx, my);
 
-            if (hoveredPage != null){
-                final String msg = this.hoveredPage.getDescription() + "\n" + TextFormatting.LIGHT_GRAY + I18n.getInstance().translateKeyAndFormat("gui.achievements.label.completion",  Math.round(hoveredPage.getCompletionFraction(statsCounter) * 100) + "%");
+            if (this.hoveredPage != null){
+                final String msg = this.hoveredPage.getDescription() + "\n" + TextFormatting.LIGHT_GRAY + I18n.getInstance().translateKeyAndFormat("gui.achievements.label.completion",  Math.round(this.hoveredPage.getCompletionFraction(this.statsCounter) * 100) + "%");
                 this.tooltip.render(msg, mx, my, TOOLTIP_OFF_X, TOOLTIP_OFF_Y, TOOLTIP_BOX_WIDTH_MIN, -1, true);
             }
         }
 
         renderLabels();
-        GL11.glEnable(GL11.GL_DEPTH_TEST);
+        GLRenderer.enableState(State.DEPTH_TEST);
 
-        hoveredAchievement = null;
-        hoveredPage = null;
+        this.hoveredAchievement = null;
+        this.hoveredPage = null;
     }
 
     @Override
 	public void tick() {
-        oldShiftX = targetShiftX;
-        oldShiftY = targetShiftY;
-        double xDiff = currentShiftX - targetShiftX;
-        double yDiff = currentShiftY - targetShiftY;
+        this.oldShiftX = this.targetShiftX;
+        this.oldShiftY = this.targetShiftY;
+        double xDiff = this.currentShiftX - this.targetShiftX;
+        double yDiff = this.currentShiftY - this.targetShiftY;
         if(xDiff * xDiff + yDiff * yDiff < 4D) {
-            targetShiftX += xDiff;
-            targetShiftY += yDiff;
+            this.targetShiftX += xDiff;
+            this.targetShiftY += yDiff;
         } else {
-            targetShiftX += xDiff * 0.85D;
-            targetShiftY += yDiff * 0.85D;
+            this.targetShiftX += xDiff * 0.85D;
+            this.targetShiftY += yDiff * 0.85D;
         }
     }
 
     protected void renderLabels() {
-        drawStringCenteredNoShadow(fontRenderer, I18n.getInstance().translateKey("gui.achievements.label.title")/* + " " + viewportZoom + " X:" + currentShiftX + ", Y:" + currentShiftY*/, width/2, 5 , 0xFFFFFF);
+        drawStringCenteredNoShadow(this.fontRenderer, I18n.getInstance().translateKey("gui.achievements.label.title")/* + " " + viewportZoom + " X:" + currentShiftX + ", Y:" + currentShiftY*/, this.width /2, 5 , 0xFFFFFF);
     }
 
 
     protected void renderAchievementsPanel(int mouseX, int mouseY, float partialTick){
-        double shiftX = MathHelper.lerp(oldShiftX, targetShiftX, partialTick);
-        double shiftY = MathHelper.lerp(oldShiftY, targetShiftY, partialTick);
-        shiftX =  MathHelper.clamp(shiftX, shiftMinX, shiftMaxX);
-        shiftY =  MathHelper.clamp(shiftY, shiftMinY, shiftMaxY);
-
-        zLevel = 0.0F;
-
-        GL11.glDepthFunc(GL11.GL_GEQUAL);
-        GL11.glPushMatrix();
-        GL11.glTranslatef(0, 0, -200F);
-        Scissor.enable(viewportLeft, viewportTop, viewportWidth, viewportHeight);
-        GL11.glEnable(GL11.GL_TEXTURE_2D);
-        GL11.glDisable(GL11.GL_LIGHTING);
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-        GL11.glEnable(GL11.GL_COLOR_MATERIAL);
-        drawRectDouble(viewportLeft, viewportTop, viewportRight, viewportBottom, 0xFF000000 | currentPage.backgroundColor()); // Ensures that the viewport always has a background of some kind
-
-        GL11.glPushMatrix();
+        double shiftX = MathHelper.lerp(this.oldShiftX, this.targetShiftX, partialTick);
+        double shiftY = MathHelper.lerp(this.oldShiftY, this.targetShiftY, partialTick);
+        shiftX =  MathHelper.clamp(shiftX, this.shiftMinX, this.shiftMaxX);
+        shiftY =  MathHelper.clamp(shiftY, this.shiftMinY, this.shiftMaxY);
+
+        this.zLevel = 0.0F;
+
+        GLRenderer.setDepthFunc(CompareFunc.GREATER_EQUAL);
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate(0, 0, -200F);
+        Scissor.enable(this.viewportLeft, this.viewportTop, this.viewportWidth, this.viewportHeight);
+//        GL11.glEnable(GL11.GL_TEXTURE_2D);
+        GLRenderer.globalSetLightEnabled(false);
+//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+//        GL11.glEnable(GL11.GL_COLOR_MATERIAL);
+        drawRectDouble(this.viewportLeft, this.viewportTop, this.viewportRight, this.viewportBottom, 0xFF000000 | this.currentPage.backgroundColor()); // Ensures that the viewport always has a background of some kind
+
+        GLRenderer.pushFrame();
         drawBackgroundTiles(shiftX, shiftY);
 
-        GL11.glEnable(GL11.GL_DEPTH_TEST);
-        GL11.glDepthFunc(GL11.GL_LEQUAL); // Responsible for culling the overdraw later on
+        GLRenderer.enableState(State.DEPTH_TEST);
+        GLRenderer.setDepthFunc(CompareFunc.LESS_EQUAL); // Responsible for culling the overdraw later on
         drawConnectingLines(mouseX, mouseY,shiftX, shiftY);
 
         Lighting.enableInventoryLight();
-        GL11.glDisable(GL11.GL_LIGHTING);
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-        GL11.glEnable(GL11.GL_COLOR_MATERIAL);
-        hoveredAchievement = drawAchievementIcons(mouseX, mouseY, shiftX, shiftY);
+        GLRenderer.globalSetLightEnabled(false);
+//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+//        GL11.glEnable(GL11.GL_COLOR_MATERIAL);
+        this.hoveredAchievement = drawAchievementIcons(mouseX, mouseY, shiftX, shiftY);
 
-        GL11.glPopMatrix();
+        GLRenderer.popFrame();
 
-        GL11.glDisable(GL11.GL_DEPTH_TEST);
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        GLRenderer.disableState(State.DEPTH_TEST);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         Scissor.disable();
 
 //        drawRectDouble(viewportLeft + viewportWidth/2d - 2.5, viewportTop + viewportHeight/2d - 2.5, viewportLeft + viewportWidth/2d + 2.5, viewportTop + viewportHeight/2d + 2.5, 0xFFA0A0A0); // Debug cross-hair
 
-        GL11.glPopMatrix();
+        GLRenderer.popFrame();
 
-        zLevel = 0.0F;
-        GL11.glDepthFunc(GL11.GL_LEQUAL);
-        GL11.glDisable(GL11.GL_DEPTH_TEST);
-        GL11.glEnable(GL11.GL_TEXTURE_2D);
+        this.zLevel = 0.0F;
+        GLRenderer.setDepthFunc(CompareFunc.LESS_EQUAL);
+        GLRenderer.disableState(State.DEPTH_TEST);
     }
 
     private static final int TILE_WIDTH = 16;
@@ -501,10 +522,12 @@ public class ScreenAchievements extends Screen
     public int lastTileY = Integer.MIN_VALUE;
     public int lastTilesWide = Integer.MIN_VALUE;
     public int lastTilesTall = Integer.MIN_VALUE;
+    public @Nullable RenderBuffer lastBackgroundTileBuf;
+    public @Nullable RenderBuffer lastBackgroundShadowBuf;
     private void drawBackgroundTiles(double shiftX, double shiftY){
-        double zoom = viewportZoom/* * 0.85*/;
+        double zoom = this.viewportZoom/* * 0.85*/;
 
-        TextureRegistry.blockAtlas.bind();
+        TextureRegistry.worldAtlas.bind();
         final int offset = 18 * TILE_WIDTH;
         int viewTileX = (MathHelper.floor(shiftX) + offset) / TILE_WIDTH;
         int viewTileY = (MathHelper.floor(shiftY) + offset) / TILE_HEIGHT;
@@ -512,8 +535,8 @@ public class ScreenAchievements extends Screen
         double remainderY = (shiftY + offset) % TILE_HEIGHT;
         Random random = new Random();
 
-        int tilesWide = (int) (viewportWidth/(TILE_WIDTH * zoom) + 2);
-        int tilesTall = (int) (viewportHeight/(TILE_HEIGHT * zoom) + 2);
+        int tilesWide = (int) (this.viewportWidth /(TILE_WIDTH * zoom) + 2);
+        int tilesTall = (int) (this.viewportHeight /(TILE_HEIGHT * zoom) + 2);
 
         int orgX = -tilesWide/2 - 1;
         int orgY = -tilesTall/2 - 1;
@@ -524,17 +547,19 @@ public class ScreenAchievements extends Screen
         tilesTall = endY - orgY;
 
         // Cache background, saves some render time which is nice
-        if (viewTileX != lastTileX || viewTileY != lastTileY || tilesWide != lastTilesWide || tilesTall != lastTilesTall) {
-            lastTileX = viewTileX;
-            lastTileY = viewTileY;
-            lastTilesWide = tilesWide;
-            lastTilesTall = tilesTall;
-
-            for (BGLayer layer : layers){
+        boolean dirty = false;
+        if (viewTileX != this.lastTileX || viewTileY != this.lastTileY || tilesWide != this.lastTilesWide || tilesTall != this.lastTilesTall) {
+            this.lastTileX = viewTileX;
+            this.lastTileY = viewTileY;
+            this.lastTilesWide = tilesWide;
+            this.lastTilesTall = tilesTall;
+            dirty = true;
+
+            for (BGLayer layer : this.layers){
                 layer.resize(tilesWide, tilesTall);
             }
 
-            long worldSeed = mc.currentWorld == null ? 0 : mc.currentWorld.getRandomSeed();
+            long worldSeed = this.mc.currentWorld == null ? 0 : this.mc.currentWorld.getRandomSeed();
             for (int _y = 0; _y < tilesTall; _y++){
                 for (int _x = 0; _x < tilesWide; _x++) {
                     int tileX = orgX + _x + viewTileX;
@@ -549,9 +574,9 @@ public class ScreenAchievements extends Screen
 
                     long seed = Objects.hash(l1, l2, ~l3);
 
-                    for (BGLayer layer : layers) {
+                    for (BGLayer layer : this.layers) {
                         random.setSeed(seed);
-                        IconCoordinate fore = currentPage.getBackgroundTile(this, layer.id, random, tileX, tileY);
+                        IconCoordinate fore = this.currentPage.getBackgroundTile(this, layer.id, random, tileX, tileY);
                         layer.put(fore, _x, _y);
                     }
                 }
